(* as_lib_cert.v *)
(* Defines the adress space library certified module  *)
(* M_{PMAP}, L_{PMAP} |- C^{as} : Psi^{as} *)

(* Uses as_reserve and as_release files to prove individual procedures *)

Require Import label.
Require Import spec.
Require Import c.
Require Import pmap.
Require Import pmap_lib.
Require Import mach.as_sig.

Require Import as_reserve.
Require Import as_release.

Require Import zbool_assist.
Require Import actsmp.



Definition as_lib_code : C_PMAP.SCAP.CodeHeap := fun l =>
  match l with
  | as_release_label => Some as_release.as_release
  | as_reserve_label => Some as_reserve.as_reserve
  | _ => None
  end.

Lemma WF_as_lib : C_PMAP.SCAP.WFCode C_PMAP.State.expr_to_Prop C_PMAP.Mc_Machine 
               PMAP_Lib.pmap_lib_spec as_lib_code as_sig.as_spec.
apply C_PMAP.SCAP.WFCode_1 with as_sig.lib_as_disj.
intros.
red in H.
destruct f; autosolve.

(* as_reserve *)
inversion_clear H.
exists as_reserve.as_reserve.
split; auto.
apply C_PMAP.SCAP.Process.WFProc_strengthen with PMAP_Lib.pmap_lib_spec.
(** SpecHeap_join_stronger **)
red; intros.
unfold C_PMAP.SCAP.SpecHeap.SpecHeap_join.
makenew' (PMAP_Lib.pmap_lib_spec l); autosolve.
apply ActionGTE_refl.
(****)
apply as_reserve.WF_as_reserve.

(* as_release *)
inversion_clear H.
exists as_release.as_release.
split; auto.
apply C_PMAP.SCAP.Process.WFProc_strengthen with PMAP_Lib.pmap_lib_spec.
apply C_PMAP.SCAP.SpecHeap.SpecHeap_stronger_add.
apply as_release.WF_as_release.
Qed.
